require 'rails_helper'
require 'devise/jwt/test_helpers'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.
#
# Also compared to earlier versions of this generator, there are no longer any
# expectations of assigns and templates rendered. These features have been
# removed from Rails core in Rails 5, but can be added back in via the
# `rails-controller-testing` gem.


RSpec.describe UsersController, type: :controller do

  # This should return the minimal set of attributes required to create a valid
  # User. As you add validations to User, be sure to
  # adjust the attributes here as well.
  before :all do
    @team = FactoryBot.create(:team)
    @igem_user = FactoryBot.create(:igem_user, team: @team)
    @user = FactoryBot.create(:user, igem_user: @igem_user, team: @team)
    # Update IgemUSer User
    @user.update(igem_user: @igem_user)
    # Update User IgemUser
    @user.update(igem_user_id: @igem_user.id)
  end

  let(:auth_headers) do
    headers = { 'Accept' => 'application/json', 'Content-Type' => 'application/json' }
    Devise::JWT::TestHelpers.auth_headers(headers, @user)
  end

  let(:valid_attributes) {
    attr = FactoryBot.build(:user, team: @user.team).attributes
    attr["password"] = "somepass"
    attr
  }

  let(:invalid_attributes) {
    FactoryBot.attributes_for(:user_invalid)
  }

  before :each do
    request.headers.merge! auth_headers
  end


  describe "GET #index" do
    before :all do
      @user.add_role :admin
    end

    it "returns a success response" do
      user = User.create! valid_attributes
      get :index, params: {}
      expect(response).to be_successful
    end
  end

  describe "GET #show" do
    it "returns a success response" do
      user = User.create! valid_attributes
      get :show, params: {id: user.to_param}
      expect(response).to be_successful
    end
  end

  describe "GET #exist" do
    context "with valid params" do
      it "returns a success response" do
        get :exist, params: {username: @user.username}
        expect(response).to have_http_status(:ok)
      end
    end

    context "with invalid params" do
      it "returns a 404 response" do
        get :exist, params: {username: "WhoAreYou"}
        expect(response).to have_http_status(:not_found)
      end
    end
  end

  # describe "POST #create" do
  #   context "with valid params" do
  #     it "creates a new User" do
  #       expect {
  #         post :create, params: {user: valid_attributes}
  #       }.to change(User, :count).by(1)
  #     end
  #
  #     it "renders a JSON response with the new user" do
  #
  #       post :create, params: {user: valid_attributes}
  #       expect(response).to have_http_status(:created)
  #       expect(response.content_type).to eq('application/json; charset=utf-8')
  #       expect(response.location).to eq(user_url(User.last))
  #     end
  #   end
  #
  #   context "with invalid params" do
  #     it "renders a JSON response with errors for the new user" do
  #
  #       post :create, params: {user: invalid_attributes}
  #       expect(response).to have_http_status(:unprocessable_entity)
  #       expect(response.content_type).to eq('application/json; charset=utf-8')
  #     end
  #   end
  # end

  describe "PUT #update" do
    context "with valid params" do
      before :all do
        @new_user = FactoryBot.build(:user, team: @user.team)
      end

      let(:new_attributes) {
        @new_user.attributes
      }

      it "updates the requested user" do
        user = User.create! valid_attributes
        put :update, params: {id: user.to_param, user: new_attributes}
        user.reload
        expect(user.username).to match @new_user.username
      end

      it "renders a JSON response with the user" do
        user = User.create! valid_attributes
        put :update, params: {id: user.to_param, user: valid_attributes}
        expect(response).to have_http_status(:ok)
        expect(response.content_type).to eq('application/json; charset=utf-8')
      end
    end

    context "with invalid params" do
      it "renders a JSON response with errors for the user" do
        user = User.create! valid_attributes

        put :update, params: {id: user.to_param, user: invalid_attributes}
        expect(response).to have_http_status(:unprocessable_entity)
        expect(response.content_type).to eq('application/json; charset=utf-8')
      end
    end
  end

  describe "DELETE #destroy" do
    it "destroys the requested user" do
      user = User.create! valid_attributes
      expect {
        delete :destroy, params: {id: user.to_param}
      }.to change(User, :count).by(-1)
    end
  end
end
